config/routes.rb
Rails.application.routes.draw do

  namespace :manifests do
    resources :services
  end
  namespace :manifests do
    resources :canvases
  end
  namespace :manifests do
    resources :resources
  end
  namespace :manifests do
    resources :images
  end
  namespace :manifests do
    end
  namespace :manifests do
    resources :sequences
  end
  namespace :manifests do
    resources :manifests
  end

  devise_for :users, :controllers => { :omniauth_callbacks => "users/omniauth_callbacks" }

  root 'home#index'

  get '/:id', to: 'home#viewer', constraints: { id: /\d/ }

  get '/rooms/:name', to: 'rooms#show'

  get '/mirador', to: 'mirador#index'

  constraints format: 'json' do
    get '/api/settings', to: 'api#settings'
    get '/api/tag_hierarchy', to: 'api#tag_hierarchy'
  end

  get '/login', to: 'application#login'
  get '/logout', to: 'application#logout'

  namespace :manifests do
    get '/api/image_service', to: 'api#image_service'
    get '/api/ingest', to: 'api#ingest'
  end

  namespace :admin do
    resources :manifests
    resources :rooms
    resources :settings
    resources :user_roles

    get '/', to: 'home#index'
    get '/import', to: 'import#index'
    post '/import/import_user_roles', to: 'import#import_user_roles'
    post '/import/import_rooms', to: 'import#import_rooms'
    post '/import/import_manifests', to: 'import#import_manifests'
  end
end

app/models/admin/setting.rb
class Admin::Setting < ActiveRecord::Base
end

app/controllers/admin/settings_controller.rb
class Admin::SettingsController < ApplicationController
  before_action :set_admin_setting, only: [:show, :edit, :update, :destroy]

  # GET /admin/settings
  # GET /admin/settings.json
  def index
    @admin_settings = Admin::Setting.all
  end

  # GET /admin/settings/1
  # GET /admin/settings/1.json
  def show
  end

  # GET /admin/settings/new
  def new
    @admin_setting = Admin::Setting.new
  end

  # GET /admin/settings/1/edit
  def edit
  end

  # POST /admin/settings
  # POST /admin/settings.json
  def create
    @admin_setting = Admin::Setting.new(admin_setting_params)

    respond_to do |format|
      if @admin_setting.save
        format.html { redirect_to @admin_setting, notice: 'Setting was successfully created.' }
        format.json { render :show, status: :created, location: @admin_setting }
      else
        format.html { render :new }
        format.json { render json: @admin_setting.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /admin/settings/1
  # PATCH/PUT /admin/settings/1.json
  def update
    respond_to do |format|
      if @admin_setting.update(admin_setting_params)
        format.html { redirect_to @admin_setting, notice: 'Setting was successfully updated.' }
        format.json { render :show, status: :ok, location: @admin_setting }
      else
        format.html { render :edit }
        format.json { render json: @admin_setting.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /admin/settings/1
  # DELETE /admin/settings/1.json
  def destroy
    @admin_setting.destroy
    respond_to do |format|
      format.html { redirect_to admin_settings_url, notice: 'Setting was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_admin_setting
      @admin_setting = Admin::Setting.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def admin_setting_params
      params.require(:admin_setting).permit(:site_name, :landing_path,
        :endpoint_url, :maintenance_mode, :maintenance_message,
        :disable_authentication, :fix_anno_cell_height, :tooltip_styles,
        :ui_annotations_overlay, :site_mirador_settings)
    end
end

app/helpers/admin/settings_helper.rb
module Admin::SettingsHelper
end

app/views/admin/settings/_form.html.erb
<%= form_for(@admin_setting, html: { class: 'ui form' }) do |f| %>
  <% if @admin_setting.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@admin_setting.errors.count, "error") %> prohibited this admin_setting from being saved:</h2>

      <ul>
      <% @admin_setting.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :site_name %><br>
    <%= f.text_field :site_name %>
  </div>

  <div class="field">
    <%= f.label :landing_path %><br>
    <%= f.text_field :landing_path %>
  </div>

  <div class="field">
    <%= f.label :endpoint_url %><br>
    <%= f.text_field :endpoint_url %>
  </div>

  <div class="field">
    <%= f.label :maintenance_mode %><br>
    <%= f.check_box :maintenance_mode %>
  </div>

  <div class="field">
    <%= f.label :maintenance_message %><br>
    <%= f.text_field :maintenance_message %>
  </div>

  <div class="field">
    <%= f.label :disable_authentication %><br>
    <%= f.check_box :disable_authentication %>
  </div>

  <div class="field">
    <%= f.label :fix_anno_cell_height %><br>
    <%= f.check_box :fix_anno_cell_height %>
  </div>

  <div class="field">
    <%= f.label :tooltip_styles %><br>
    <%= f.text_area :tooltip_styles %>
  </div>

  <div class="field">
    <%= f.label :ui_annotations_overlay %><br>
    <%= f.text_area :ui_annotations_overlay %>
  </div>

 <div class="field">
    <%= f.label :site_mirador_settings %><br>
    <%= f.text_area :site_mirador_settings, cols: "80", rows: "25", style: "font-family: monospace" %>
  </div>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

<br/>

app/views/admin/settings/edit.html.erb
<div class="ui container">
  <div class="ui grid">
    <div class="column">

<h1>Editing Admin Setting</h1>

<%= render 'form' %>

<%= link_to 'Show', @admin_setting %> |
<%= link_to 'Back', admin_settings_path %>

    </div>
  </div>
</div>

app/views/admin/settings/index.html.erb
<div class="ui container">
  <div class="ui grid">
    <div class="column">

<p id="notice"><%= notice %></p>

<h1>Listing Admin Settings</h1>

<table class="ui celled table">
  <thead>
    <tr>
      <th>Site name</th>
      <th>Landing path</th>
      <th>Endpoint url</th>
      <th>Maintenance mode</th>
      <th>Maintenance message</th>
      <th>Disable authentication</th>
      <th>Fix annotation cell height</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @admin_settings.each do |admin_setting| %>
      <tr>
        <td><%= admin_setting.site_name %></td>
        <td><%= admin_setting.landing_path %></td>
        <td><%= admin_setting.endpoint_url %></td>
        <td><%= admin_setting.maintenance_mode %></td>
        <td><%= admin_setting.maintenance_message %></td>
        <td><%= admin_setting.disable_authentication %></td>
        <td><%= admin_setting.fix_anno_cell_height %></td>
        <td><%= link_to 'Show', admin_setting %></td>
        <td><%= link_to 'Edit', edit_admin_setting_path(admin_setting) %></td>
        <td><%= link_to 'Destroy', admin_setting, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Setting', new_admin_setting_path %>

    </div>
  </div>
</div>

app/views/admin/settings/new.html.erb
<div class="ui container">
  <div class="ui grid">
    <div class="column">

<h1>New Admin Setting</h1>

<%= render 'form' %>

<%= link_to 'Back', admin_settings_path %>

    </div>
  </div>
</div>

app/views/admin/settings/show.html.erb
<div class="ui container">
  <div class="ui grid">
    <div class="column">

<p id="notice"><%= notice %></p>

<p>
  <strong>Site name:</strong>
  <%= @admin_setting.site_name %>
</p>

<p>
  <strong>Landing path:</strong>
  <%= @admin_setting.landing_path %>
</p>

<p>
  <strong>Endpoint url:</strong>
  <%= @admin_setting.endpoint_url %>
</p>

<p>
  <strong>Maintenance mode:</strong>
  <%= @admin_setting.maintenance_mode %>
</p>

<p>
  <strong>Maintenance message:</strong>
  <%= @admin_setting.maintenance_message %>
</p>

<p>
  <strong>Disable authentication:</strong>
  <%= @admin_setting.disable_authentication %>
</p>

<p>
  <strong>Fix annotation cell height:</strong>
  <%= @admin_setting.fix_anno_cell_height %>
</p>

<p>
  <strong>Tooltip Styles:</strong>
  <%= @admin_setting.tooltip_styles %>
</p>

<p>
  <strong>UI - Annotations Overlay</strong>
  <%= @admin_setting.ui_annotations_overlay %>
</p>

<p>
  <strong>Site Mirador Settings</strong>
  <%= @admin_setting.site_mirador_settings %>
</p>

<%= link_to 'Edit', edit_admin_setting_path(@admin_setting) %> |
<%= link_to 'Back', admin_settings_path %>

    </div>
  </div>
</div>